<html>
<head>
<title>OgreDeflate.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreDeflate.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreDeflate_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment"> This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment"> (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment"> For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"> </span>
<a name="l00007"></a>00007 <span class="comment"> Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"> </span>
<a name="l00009"></a>00009 <span class="comment"> Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment"> of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment"> in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment"> to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment"> copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment"> furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"> </span>
<a name="l00016"></a>00016 <span class="comment"> The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment"> all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"> </span>
<a name="l00019"></a>00019 <span class="comment"> THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment"> IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment"> FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment"> AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment"> LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment"> OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment"> THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __OGRE_DEFLATE_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __OGRE_DEFLATE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00036"></a>00036 <span class="keyword">struct </span>z_stream_s;
<a name="l00037"></a><a class="code" href="OgreDeflate_8h.html#aa4751fbf6d882976fb300ea9815f5010">00037</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>z_stream_s <a class="code" href="OgreDeflate_8h.html#aa4751fbf6d882976fb300ea9815f5010">z_stream</a>;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre
<a name="l00040"></a>00040 {
<a name="l00055"></a><a class="code" href="classOgre_1_1DeflateStream.html">00055</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1DeflateStream.html" title="Stream which compresses / uncompresses data using the &#39;deflate&#39; compression algorithm.">DeflateStream</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1DataStream.html" title="General purpose class used for encapsulating the reading and writing of data.">DataStream</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">protected</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1DeflateStream.html#a024e93885096fa4ad173eeaff662db58">00058</a>         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1DeflateStream.html#a024e93885096fa4ad173eeaff662db58">mCompressedStream</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1DeflateStream.html#a128d2927cfb876b9a6e1d28b44af3f1e">00059</a>         <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a> <a class="code" href="classOgre_1_1DeflateStream.html#a128d2927cfb876b9a6e1d28b44af3f1e">mTmpWriteStream</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1DeflateStream.html#adfb37cc37e17df4c0d734bbf55f98f90">00060</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1DeflateStream.html#adfb37cc37e17df4c0d734bbf55f98f90">mTempFileName</a>;
<a name="l00061"></a><a class="code" href="classOgre_1_1DeflateStream.html#a85ce03abdcfb8904a942cc2e0eafa7c8">00061</a>         <a class="code" href="OgreDeflate_8h.html#aa4751fbf6d882976fb300ea9815f5010">z_stream</a>* <a class="code" href="classOgre_1_1DeflateStream.html#a85ce03abdcfb8904a942cc2e0eafa7c8">mZStream</a>;
<a name="l00062"></a><a class="code" href="classOgre_1_1DeflateStream.html#a691e32453639f8356ba7b66edc650a7f">00062</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1DeflateStream.html#a691e32453639f8356ba7b66edc650a7f">mCurrentPos</a>;
<a name="l00063"></a>00063         
<a name="l00065"></a><a class="code" href="classOgre_1_1DeflateStream.html#a4349212fc17bf2346574bc636d036d92">00065</a>         <a class="code" href="classOgre_1_1StaticCache.html">StaticCache&lt;16 * OGRE_STREAM_TEMP_SIZE&gt;</a> <a class="code" href="classOgre_1_1DeflateStream.html#a4349212fc17bf2346574bc636d036d92" title="Cache for read data in case skipping around.">mReadCache</a>;
<a name="l00066"></a>00066         
<a name="l00068"></a><a class="code" href="classOgre_1_1DeflateStream.html#a249843cf1386300d0ccae577d29fc363">00068</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> *<a class="code" href="classOgre_1_1DeflateStream.html#a249843cf1386300d0ccae577d29fc363" title="Intermediate buffer for read / write.">mTmp</a>;
<a name="l00069"></a>00069         
<a name="l00071"></a><a class="code" href="classOgre_1_1DeflateStream.html#a418d2338032eec00e54624700ab8ba22">00071</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DeflateStream.html#a418d2338032eec00e54624700ab8ba22" title="Whether the underlying stream is valid compressed data.">mIsCompressedValid</a>;
<a name="l00072"></a>00072         
<a name="l00073"></a>00073         
<a name="l00074"></a>00074         <span class="keywordtype">void</span> init();
<a name="l00075"></a>00075         <span class="keywordtype">void</span> destroy();
<a name="l00076"></a>00076         <span class="keywordtype">void</span> compressFinal();
<a name="l00077"></a>00077     <span class="keyword">public</span>:
<a name="l00083"></a>00083         <a class="code" href="classOgre_1_1DeflateStream.html" title="Stream which compresses / uncompresses data using the &#39;deflate&#39; compression algorithm.">DeflateStream</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; compressedStream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; tmpFileName = <span class="stringliteral">&quot;&quot;</span>);
<a name="l00090"></a>00090         <a class="code" href="classOgre_1_1DeflateStream.html" title="Stream which compresses / uncompresses data using the &#39;deflate&#39; compression algorithm.">DeflateStream</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; compressedStream, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; tmpFileName=<span class="stringliteral">&quot;&quot;</span>); 
<a name="l00091"></a>00091         
<a name="l00092"></a>00092         ~<a class="code" href="classOgre_1_1DeflateStream.html" title="Stream which compresses / uncompresses data using the &#39;deflate&#39; compression algorithm.">DeflateStream</a>();
<a name="l00093"></a>00093         
<a name="l00100"></a><a class="code" href="classOgre_1_1DeflateStream.html#accce1307c2fadcb102817b6c2e37bdd3">00100</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1DeflateStream.html#accce1307c2fadcb102817b6c2e37bdd3" title="Returns whether the compressed stream is valid deflated data.">isCompressedStreamValid</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mIsCompressedValid; }
<a name="l00101"></a>00101         
<a name="l00104"></a>00104         <span class="keywordtype">size_t</span> read(<span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00105"></a>00105         
<a name="l00108"></a>00108         <span class="keywordtype">size_t</span> write(<span class="keyword">const</span> <span class="keywordtype">void</span>* buf, <span class="keywordtype">size_t</span> count);
<a name="l00109"></a>00109                 
<a name="l00112"></a>00112         <span class="keywordtype">void</span> skip(<span class="keywordtype">long</span> count);
<a name="l00113"></a>00113         
<a name="l00116"></a>00116         <span class="keywordtype">void</span> seek( <span class="keywordtype">size_t</span> pos );
<a name="l00117"></a>00117         
<a name="l00120"></a>00120         <span class="keywordtype">size_t</span> tell(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00121"></a>00121         
<a name="l00124"></a>00124         <span class="keywordtype">bool</span> eof(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00125"></a>00125         
<a name="l00128"></a>00128         <span class="keywordtype">void</span> close(<span class="keywordtype">void</span>);
<a name="l00129"></a>00129         
<a name="l00130"></a>00130     };
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
